package com.trolltech.qt.core;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QFile extends com.trolltech.qt.core.QIODevice
{
    public enum FileError implements com.trolltech.qt.QtEnumerator {
        NoError(0),
        ReadError(1),
        WriteError(2),
        FatalError(3),
        ResourceError(4),
        OpenError(5),
        AbortError(6),
        TimeOutError(7),
        UnspecifiedError(8),
        RemoveError(9),
        RenameError(10),
        PositionError(11),
        ResizeError(12),
        PermissionsError(13),
        CopyError(14);

        FileError(int value) { this.value = value; }
        public int value() { return value; }

        public static FileError resolve(int value) {
            return (FileError) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoError;
            case 1: return ReadError;
            case 2: return WriteError;
            case 3: return FatalError;
            case 4: return ResourceError;
            case 5: return OpenError;
            case 6: return AbortError;
            case 7: return TimeOutError;
            case 8: return UnspecifiedError;
            case 9: return RemoveError;
            case 10: return RenameError;
            case 11: return PositionError;
            case 12: return ResizeError;
            case 13: return PermissionsError;
            case 14: return CopyError;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum Permission implements com.trolltech.qt.QtEnumerator {
        ReadOwner(16384),
        WriteOwner(8192),
        ExeOwner(4096),
        ReadUser(1024),
        WriteUser(512),
        ExeUser(256),
        ReadGroup(64),
        WriteGroup(32),
        ExeGroup(16),
        ReadOther(4),
        WriteOther(2),
        ExeOther(1);

        Permission(int value) { this.value = value; }
        public int value() { return value; }

        public static Permissions createQFlags(Permission ... values) {
            return new Permissions(values);
        }
        public static Permission resolve(int value) {
            return (Permission) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 16384: return ReadOwner;
            case 8192: return WriteOwner;
            case 4096: return ExeOwner;
            case 1024: return ReadUser;
            case 512: return WriteUser;
            case 256: return ExeUser;
            case 64: return ReadGroup;
            case 32: return WriteGroup;
            case 16: return ExeGroup;
            case 4: return ReadOther;
            case 2: return WriteOther;
            case 1: return ExeOther;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class Permissions extends com.trolltech.qt.QFlags<Permission> {
        private static final long serialVersionUID = 1L;
        public Permissions(Permission ... args) { super(args); }
        public Permissions(int value) { setValue(value); }
    }


    public QFile(java.lang.String name) {
        super((QPrivateConstructor)null);
        __qt_QFile_String(name);
    }
    private native void __qt_QFile_String(java.lang.String name);


    public QFile(java.lang.String name, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QFile_String_QObject(name, parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QFile_String_QObject(java.lang.String name, long parent);


    public QFile() {
        super((QPrivateConstructor)null);
        __qt_QFile();
    }
    private native void __qt_QFile();


    public QFile(com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QFile_QObject(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QFile_QObject(long parent);


    @QtBlockedSlot public final boolean copy(java.lang.String newName) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_copy_String(nativeId(), newName);
    }
    private native static boolean __qt_copy_String(long __this__nativeId, java.lang.String newName);

    @QtBlockedSlot public final com.trolltech.qt.core.QFile.FileError error() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.QFile.FileError.resolve(__qt_error(nativeId()));
    }
    private native static int __qt_error(long __this__nativeId);

    @QtBlockedSlot public final boolean exists() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_exists(nativeId());
    }
    private native static boolean __qt_exists(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String fileName() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fileName(nativeId());
    }
    private native static java.lang.String __qt_fileName(long __this__nativeId);

    @QtBlockedSlot public final boolean flush() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_flush(nativeId());
    }
    private native static boolean __qt_flush(long __this__nativeId);

    @QtBlockedSlot public final int handle() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_handle(nativeId());
    }
    private native static int __qt_handle(long __this__nativeId);

    @QtBlockedSlot public final boolean link(java.lang.String newName) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_link_String(nativeId(), newName);
    }
    private native static boolean __qt_link_String(long __this__nativeId, java.lang.String newName);


    @QtBlockedSlot public final boolean open(int fd, com.trolltech.qt.core.QIODevice.OpenModeFlag ... flags) {
        return this.open(fd, new com.trolltech.qt.core.QIODevice.OpenMode(flags));
    }
    @QtBlockedSlot public final boolean open(int fd, com.trolltech.qt.core.QIODevice.OpenMode flags) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_open_int_OpenMode(nativeId(), fd, flags.value());
    }
    private native static boolean __qt_open_int_OpenMode(long __this__nativeId, int fd, int flags);

    @QtBlockedSlot public final com.trolltech.qt.core.QFile.Permissions permissions() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.core.QFile.Permissions(__qt_permissions(nativeId()));
    }
    private native static int __qt_permissions(long __this__nativeId);

    @QtBlockedSlot public final boolean remove() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_remove(nativeId());
    }
    private native static boolean __qt_remove(long __this__nativeId);

    @QtBlockedSlot public final boolean rename(java.lang.String newName) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_rename_String(nativeId(), newName);
    }
    private native static boolean __qt_rename_String(long __this__nativeId, java.lang.String newName);

    @QtBlockedSlot public final boolean resize(long sz) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_resize_long(nativeId(), sz);
    }
    private native static boolean __qt_resize_long(long __this__nativeId, long sz);

    @QtBlockedSlot public final void setFileName(java.lang.String name) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setFileName_String(nativeId(), name);
    }
    private native static void __qt_setFileName_String(long __this__nativeId, java.lang.String name);


    @QtBlockedSlot public final boolean setPermissions(com.trolltech.qt.core.QFile.Permission ... permissionSpec) {
        return this.setPermissions(new com.trolltech.qt.core.QFile.Permissions(permissionSpec));
    }
    @QtBlockedSlot public final boolean setPermissions(com.trolltech.qt.core.QFile.Permissions permissionSpec) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setPermissions_Permissions(nativeId(), permissionSpec.value());
    }
    private native static boolean __qt_setPermissions_Permissions(long __this__nativeId, int permissionSpec);

    @QtBlockedSlot public final java.lang.String symLinkTarget() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_symLinkTarget(nativeId());
    }
    private native static java.lang.String __qt_symLinkTarget(long __this__nativeId);

    @QtBlockedSlot public final void unsetError() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_unsetError(nativeId());
    }
    private native static void __qt_unsetError(long __this__nativeId);

    @QtBlockedSlot public boolean atEnd() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_atEnd(nativeId());
    }
    private native static boolean __qt_atEnd(long __this__nativeId);

    @QtBlockedSlot public void close() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_close(nativeId());
    }
    private native static void __qt_close(long __this__nativeId);

    @QtBlockedSlot public com.trolltech.qt.core.QAbstractFileEngine fileEngine() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_fileEngine(nativeId());
    }
    private native static com.trolltech.qt.core.QAbstractFileEngine __qt_fileEngine(long __this__nativeId);

    @QtBlockedSlot public boolean isSequential() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSequential(nativeId());
    }
    private native static boolean __qt_isSequential(long __this__nativeId);

    @QtBlockedSlot public boolean open(com.trolltech.qt.core.QIODevice.OpenMode flags) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_open_OpenMode(nativeId(), flags.value());
    }
    private native static boolean __qt_open_OpenMode(long __this__nativeId, int flags);

    @QtBlockedSlot public long pos() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_pos(nativeId());
    }
    private native static long __qt_pos(long __this__nativeId);

    @QtBlockedSlot protected int readData(byte[] data) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readData_nativepointer_long(nativeId(), data);
    }
    private native static int __qt_readData_nativepointer_long(long __this__nativeId, byte[] data);

    @QtBlockedSlot protected int readLineData(byte[] data) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readLineData_nativepointer_long(nativeId(), data);
    }
    private native static int __qt_readLineData_nativepointer_long(long __this__nativeId, byte[] data);

    @QtBlockedSlot public boolean seek(long offset) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_seek_long(nativeId(), offset);
    }
    private native static boolean __qt_seek_long(long __this__nativeId, long offset);

    @QtBlockedSlot public long size() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_size(nativeId());
    }
    private native static long __qt_size(long __this__nativeId);

    @QtBlockedSlot protected int writeData(byte[] data) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_writeData_nativepointer_long(nativeId(), data);
    }
    private native static int __qt_writeData_nativepointer_long(long __this__nativeId, byte[] data);

    public native static boolean copy(java.lang.String fileName, java.lang.String newName);

    public static java.lang.String decodeName(com.trolltech.qt.core.QByteArray localFileName) {
        return __qt_decodeName_QByteArray(localFileName == null ? (localFileName = new com.trolltech.qt.core.QByteArray()).nativeId() : localFileName.nativeId());
    }
    private native static java.lang.String __qt_decodeName_QByteArray(long localFileName);

    @SuppressWarnings("unused")
    private native static java.lang.String decodeName(com.trolltech.qt.QNativePointer localFileName);

    public native static com.trolltech.qt.core.QByteArray encodeName(java.lang.String fileName);

    public native static boolean exists(java.lang.String fileName);

    public native static boolean link(java.lang.String oldname, java.lang.String newName);

    public static com.trolltech.qt.core.QFile.Permissions permissions(java.lang.String filename) {
        return new com.trolltech.qt.core.QFile.Permissions(__qt_permissions_String(filename));
    }
    private native static int __qt_permissions_String(java.lang.String filename);

    public native static boolean remove(java.lang.String fileName);

    public native static boolean rename(java.lang.String oldName, java.lang.String newName);

    public native static boolean resize(java.lang.String filename, long sz);


    public static boolean setPermissions(java.lang.String filename, com.trolltech.qt.core.QFile.Permission ... permissionSpec) {
        return com.trolltech.qt.core.QFile.setPermissions(filename, new com.trolltech.qt.core.QFile.Permissions(permissionSpec));
    }
    public static boolean setPermissions(java.lang.String filename, com.trolltech.qt.core.QFile.Permissions permissionSpec) {
        return __qt_setPermissions_String_Permissions(filename, permissionSpec.value());
    }
    private native static boolean __qt_setPermissions_String_Permissions(java.lang.String filename, int permissionSpec);

    public native static java.lang.String symLinkTarget(java.lang.String fileName);


    public static native QFile fromNativePointer(QNativePointer nativePointer);

    protected QFile(QPrivateConstructor p) { super(p); } 


        public static String decodeName(String localFileName) {
            return decodeName(com.trolltech.qt.QNativePointer.createCharPointer(localFileName));
        }
    
}
