package com.trolltech.qt.gui;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QMessageBox extends com.trolltech.qt.gui.QDialog
{
    public enum ButtonRole implements com.trolltech.qt.QtEnumerator {
        InvalidRole(-1),
        AcceptRole(0),
        RejectRole(1),
        DestructiveRole(2),
        ActionRole(3),
        HelpRole(4),
        YesRole(5),
        NoRole(6),
        ResetRole(7),
        ApplyRole(8),
        NRoles(9);

        ButtonRole(int value) { this.value = value; }
        public int value() { return value; }

        public static ButtonRole resolve(int value) {
            return (ButtonRole) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case -1: return InvalidRole;
            case 0: return AcceptRole;
            case 1: return RejectRole;
            case 2: return DestructiveRole;
            case 3: return ActionRole;
            case 4: return HelpRole;
            case 5: return YesRole;
            case 6: return NoRole;
            case 7: return ResetRole;
            case 8: return ApplyRole;
            case 9: return NRoles;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum StandardButton implements com.trolltech.qt.QtEnumerator {
        NoButton(0),
        Ok(1024),
        Save(2048),
        SaveAll(4096),
        Open(8192),
        Yes(16384),
        YesToAll(32768),
        No(65536),
        NoToAll(131072),
        Abort(262144),
        Retry(524288),
        Ignore(1048576),
        Close(2097152),
        Cancel(4194304),
        Discard(8388608),
        Help(16777216),
        Apply(33554432),
        Reset(67108864),
        RestoreDefaults(134217728),
        Default(256),
        Escape(512),
        FlagMask(768),
        ButtonMask(769);

        StandardButton(int value) { this.value = value; }
        public int value() { return value; }

        public static StandardButtons createQFlags(StandardButton ... values) {
            return new StandardButtons(values);
        }
        public static StandardButton resolve(int value) {
            return (StandardButton) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoButton;
            case 1024: return Ok;
            case 2048: return Save;
            case 4096: return SaveAll;
            case 8192: return Open;
            case 16384: return Yes;
            case 32768: return YesToAll;
            case 65536: return No;
            case 131072: return NoToAll;
            case 262144: return Abort;
            case 524288: return Retry;
            case 1048576: return Ignore;
            case 2097152: return Close;
            case 4194304: return Cancel;
            case 8388608: return Discard;
            case 16777216: return Help;
            case 33554432: return Apply;
            case 67108864: return Reset;
            case 134217728: return RestoreDefaults;
            case 256: return Default;
            case 512: return Escape;
            case 768: return FlagMask;
            case 769: return ButtonMask;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public static class StandardButtons extends com.trolltech.qt.QFlags<StandardButton> {
        private static final long serialVersionUID = 1L;
        public StandardButtons(StandardButton ... args) { super(args); }
        public StandardButtons(int value) { setValue(value); }
    }

    public enum Icon implements com.trolltech.qt.QtEnumerator {
        NoIcon(0),
        Information(1),
        Warning(2),
        Critical(3),
        Question(4);

        Icon(int value) { this.value = value; }
        public int value() { return value; }

        public static Icon resolve(int value) {
            return (Icon) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return NoIcon;
            case 1: return Information;
            case 2: return Warning;
            case 3: return Critical;
            case 4: return Question;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }


    public QMessageBox() {
        this((com.trolltech.qt.gui.QWidget)null);
    }
    public QMessageBox(com.trolltech.qt.gui.QWidget parent) {
        super((QPrivateConstructor)null);
        __qt_QMessageBox_QWidget(parent == null ? 0 : parent.nativeId());
    }
    private native void __qt_QMessageBox_QWidget(long parent);



    public QMessageBox(com.trolltech.qt.gui.QMessageBox.Icon icon, java.lang.String title, java.lang.String text, com.trolltech.qt.gui.QMessageBox.StandardButtons buttons, com.trolltech.qt.gui.QWidget parent) {
        this(icon, title, text, buttons, parent, new com.trolltech.qt.core.Qt.WindowFlags(259));
    }

    public QMessageBox(com.trolltech.qt.gui.QMessageBox.Icon icon, java.lang.String title, java.lang.String text, com.trolltech.qt.gui.QMessageBox.StandardButtons buttons) {
        this(icon, title, text, buttons, (com.trolltech.qt.gui.QWidget)null, new com.trolltech.qt.core.Qt.WindowFlags(259));
    }

    public QMessageBox(com.trolltech.qt.gui.QMessageBox.Icon icon, java.lang.String title, java.lang.String text) {
        this(icon, title, text, new com.trolltech.qt.gui.QMessageBox.StandardButtons(0), (com.trolltech.qt.gui.QWidget)null, new com.trolltech.qt.core.Qt.WindowFlags(259));
    }
    public QMessageBox(com.trolltech.qt.gui.QMessageBox.Icon icon, java.lang.String title, java.lang.String text, com.trolltech.qt.gui.QMessageBox.StandardButtons buttons, com.trolltech.qt.gui.QWidget parent, com.trolltech.qt.core.Qt.WindowFlags f) {
        super((QPrivateConstructor)null);
        __qt_QMessageBox_Icon_String_String_StandardButtons_QWidget_WindowFlags(icon.value(), title, text, buttons.value(), parent == null ? 0 : parent.nativeId(), f.value());
    }
    private native void __qt_QMessageBox_Icon_String_String_StandardButtons_QWidget_WindowFlags(int icon, java.lang.String title, java.lang.String text, int buttons, long parent, int f);


    @QtBlockedSlot public final void addButton(com.trolltech.qt.gui.QAbstractButton button, com.trolltech.qt.gui.QMessageBox.ButtonRole role) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_addButton_QAbstractButton_ButtonRole(nativeId(), button == null ? 0 : button.nativeId(), role.value());
    }
    private native static void __qt_addButton_QAbstractButton_ButtonRole(long __this__nativeId, long button, int role);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPushButton addButton(com.trolltech.qt.gui.QMessageBox.StandardButton button) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addButton_StandardButton(nativeId(), button.value());
    }
    private native static com.trolltech.qt.gui.QPushButton __qt_addButton_StandardButton(long __this__nativeId, int button);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPushButton addButton(java.lang.String text, com.trolltech.qt.gui.QMessageBox.ButtonRole role) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_addButton_String_ButtonRole(nativeId(), text, role.value());
    }
    private native static com.trolltech.qt.gui.QPushButton __qt_addButton_String_ButtonRole(long __this__nativeId, java.lang.String text, int role);

    @QtBlockedSlot public final com.trolltech.qt.gui.QAbstractButton button(com.trolltech.qt.gui.QMessageBox.StandardButton which) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_button_StandardButton(nativeId(), which.value());
    }
    private native static com.trolltech.qt.gui.QAbstractButton __qt_button_StandardButton(long __this__nativeId, int which);

    @QtBlockedSlot public final com.trolltech.qt.gui.QAbstractButton clickedButton() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_clickedButton(nativeId());
    }
    private native static com.trolltech.qt.gui.QAbstractButton __qt_clickedButton(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QPushButton defaultButton() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_defaultButton(nativeId());
    }
    private native static com.trolltech.qt.gui.QPushButton __qt_defaultButton(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="detailedText")
    @com.trolltech.qt.QtPropertyOrder(5)
    @QtBlockedSlot public final java.lang.String detailedText() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_detailedText(nativeId());
    }
    private native static java.lang.String __qt_detailedText(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.gui.QAbstractButton escapeButton() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_escapeButton(nativeId());
    }
    private native static com.trolltech.qt.gui.QAbstractButton __qt_escapeButton(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="icon")
    @com.trolltech.qt.QtPropertyOrder(1)
    @QtBlockedSlot public final com.trolltech.qt.gui.QMessageBox.Icon icon() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QMessageBox.Icon.resolve(__qt_icon(nativeId()));
    }
    private native static int __qt_icon(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="iconPixmap")
    @com.trolltech.qt.QtPropertyOrder(2)
    @QtBlockedSlot public final com.trolltech.qt.gui.QPixmap iconPixmap() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_iconPixmap(nativeId());
    }
    private native static com.trolltech.qt.gui.QPixmap __qt_iconPixmap(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="informativeText")
    @com.trolltech.qt.QtPropertyOrder(6)
    @QtBlockedSlot public final java.lang.String informativeText() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_informativeText(nativeId());
    }
    private native static java.lang.String __qt_informativeText(long __this__nativeId);

    @QtBlockedSlot public final void removeButton(com.trolltech.qt.gui.QAbstractButton button) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_removeButton_QAbstractButton(nativeId(), button == null ? 0 : button.nativeId());
    }
    private native static void __qt_removeButton_QAbstractButton(long __this__nativeId, long button);

    @QtBlockedSlot public final void setDefaultButton(com.trolltech.qt.gui.QPushButton button) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDefaultButton_QPushButton(nativeId(), button == null ? 0 : button.nativeId());
    }
    private native static void __qt_setDefaultButton_QPushButton(long __this__nativeId, long button);

    @QtBlockedSlot public final void setDefaultButton(com.trolltech.qt.gui.QMessageBox.StandardButton button) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDefaultButton_StandardButton(nativeId(), button.value());
    }
    private native static void __qt_setDefaultButton_StandardButton(long __this__nativeId, int button);

    @com.trolltech.qt.QtPropertyWriter(name="detailedText")
    @QtBlockedSlot public final void setDetailedText(java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setDetailedText_String(nativeId(), text);
    }
    private native static void __qt_setDetailedText_String(long __this__nativeId, java.lang.String text);

    @QtBlockedSlot public final void setEscapeButton(com.trolltech.qt.gui.QAbstractButton button) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setEscapeButton_QAbstractButton(nativeId(), button == null ? 0 : button.nativeId());
    }
    private native static void __qt_setEscapeButton_QAbstractButton(long __this__nativeId, long button);

    @QtBlockedSlot public final void setEscapeButton(com.trolltech.qt.gui.QMessageBox.StandardButton button) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setEscapeButton_StandardButton(nativeId(), button.value());
    }
    private native static void __qt_setEscapeButton_StandardButton(long __this__nativeId, int button);

    @com.trolltech.qt.QtPropertyWriter(name="icon")
    @QtBlockedSlot public final void setIcon(com.trolltech.qt.gui.QMessageBox.Icon arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIcon_Icon(nativeId(), arg__1.value());
    }
    private native static void __qt_setIcon_Icon(long __this__nativeId, int arg__1);

    @com.trolltech.qt.QtPropertyWriter(name="iconPixmap")
    @QtBlockedSlot public final void setIconPixmap(com.trolltech.qt.gui.QPixmap pixmap) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setIconPixmap_QPixmap(nativeId(), pixmap == null ? (pixmap = new com.trolltech.qt.gui.QPixmap()).nativeId() : pixmap.nativeId());
    }
    private native static void __qt_setIconPixmap_QPixmap(long __this__nativeId, long pixmap);

    @com.trolltech.qt.QtPropertyWriter(name="informativeText")
    @QtBlockedSlot public final void setInformativeText(java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setInformativeText_String(nativeId(), text);
    }
    private native static void __qt_setInformativeText_String(long __this__nativeId, java.lang.String text);


    @QtBlockedSlot public final void setStandardButtons(com.trolltech.qt.gui.QMessageBox.StandardButton ... buttons) {
        this.setStandardButtons(new com.trolltech.qt.gui.QMessageBox.StandardButtons(buttons));
    }
    @com.trolltech.qt.QtPropertyWriter(name="standardButtons")
    @QtBlockedSlot public final void setStandardButtons(com.trolltech.qt.gui.QMessageBox.StandardButtons buttons) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setStandardButtons_StandardButtons(nativeId(), buttons.value());
    }
    private native static void __qt_setStandardButtons_StandardButtons(long __this__nativeId, int buttons);

    @com.trolltech.qt.QtPropertyWriter(name="text")
    @QtBlockedSlot public final void setText(java.lang.String text) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setText_String(nativeId(), text);
    }
    private native static void __qt_setText_String(long __this__nativeId, java.lang.String text);

    @com.trolltech.qt.QtPropertyWriter(name="textFormat")
    @QtBlockedSlot public final void setTextFormat(com.trolltech.qt.core.Qt.TextFormat format) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setTextFormat_TextFormat(nativeId(), format.value());
    }
    private native static void __qt_setTextFormat_TextFormat(long __this__nativeId, int format);

    @QtBlockedSlot public final com.trolltech.qt.gui.QMessageBox.StandardButton standardButton(com.trolltech.qt.gui.QAbstractButton button) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.gui.QMessageBox.StandardButton.resolve(__qt_standardButton_QAbstractButton(nativeId(), button == null ? 0 : button.nativeId()));
    }
    private native static int __qt_standardButton_QAbstractButton(long __this__nativeId, long button);

    @com.trolltech.qt.QtPropertyReader(name="standardButtons")
    @com.trolltech.qt.QtPropertyOrder(4)
    @QtBlockedSlot public final com.trolltech.qt.gui.QMessageBox.StandardButtons standardButtons() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return new com.trolltech.qt.gui.QMessageBox.StandardButtons(__qt_standardButtons(nativeId()));
    }
    private native static int __qt_standardButtons(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="text")
    @com.trolltech.qt.QtPropertyOrder(0)
    @QtBlockedSlot public final java.lang.String text() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_text(nativeId());
    }
    private native static java.lang.String __qt_text(long __this__nativeId);

    @com.trolltech.qt.QtPropertyReader(name="textFormat")
    @com.trolltech.qt.QtPropertyOrder(3)
    @QtBlockedSlot public final com.trolltech.qt.core.Qt.TextFormat textFormat() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.core.Qt.TextFormat.resolve(__qt_textFormat(nativeId()));
    }
    private native static int __qt_textFormat(long __this__nativeId);

    @QtBlockedSlot protected void changeEvent(com.trolltech.qt.core.QEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_changeEvent_QEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_changeEvent_QEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void closeEvent(com.trolltech.qt.gui.QCloseEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_closeEvent_QCloseEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_closeEvent_QCloseEvent(long __this__nativeId, long event);

    @QtBlockedSlot public boolean event(com.trolltech.qt.core.QEvent e) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_event_QEvent(nativeId(), e == null ? 0 : e.nativeId());
    }
    private native static boolean __qt_event_QEvent(long __this__nativeId, long e);

    @QtBlockedSlot protected void keyPressEvent(com.trolltech.qt.gui.QKeyEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_keyPressEvent_QKeyEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_keyPressEvent_QKeyEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void resizeEvent(com.trolltech.qt.gui.QResizeEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_resizeEvent_QResizeEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_resizeEvent_QResizeEvent(long __this__nativeId, long event);

    @QtBlockedSlot protected void showEvent(com.trolltech.qt.gui.QShowEvent event) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_showEvent_QShowEvent(nativeId(), event == null ? 0 : event.nativeId());
    }
    private native static void __qt_showEvent_QShowEvent(long __this__nativeId, long event);

    @QtBlockedSlot public com.trolltech.qt.core.QSize sizeHint() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_sizeHint(nativeId());
    }
    private native static com.trolltech.qt.core.QSize __qt_sizeHint(long __this__nativeId);

    public static void about(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text) {
        __qt_about_QWidget_String_String(parent == null ? 0 : parent.nativeId(), title, text);
    }
    private native static void __qt_about_QWidget_String_String(long parent, java.lang.String title, java.lang.String text);


    public static void aboutQt(com.trolltech.qt.gui.QWidget parent) {
        aboutQt(parent, (java.lang.String)"");
    }
    public static void aboutQt(com.trolltech.qt.gui.QWidget parent, java.lang.String title) {
        __qt_aboutQt_QWidget_String(parent == null ? 0 : parent.nativeId(), title);
    }
    private native static void __qt_aboutQt_QWidget_String(long parent, java.lang.String title);


    public static com.trolltech.qt.gui.QMessageBox.StandardButton critical(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text, com.trolltech.qt.gui.QMessageBox.StandardButtons buttons) {
        return critical(parent, title, text, buttons, com.trolltech.qt.gui.QMessageBox.StandardButton.NoButton);
    }

    public static com.trolltech.qt.gui.QMessageBox.StandardButton critical(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text) {
        return critical(parent, title, text, new com.trolltech.qt.gui.QMessageBox.StandardButtons(1024), com.trolltech.qt.gui.QMessageBox.StandardButton.NoButton);
    }
    public static com.trolltech.qt.gui.QMessageBox.StandardButton critical(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text, com.trolltech.qt.gui.QMessageBox.StandardButtons buttons, com.trolltech.qt.gui.QMessageBox.StandardButton defaultButton) {
        return com.trolltech.qt.gui.QMessageBox.StandardButton.resolve(__qt_critical_QWidget_String_String_StandardButtons_StandardButton(parent == null ? 0 : parent.nativeId(), title, text, buttons.value(), defaultButton.value()));
    }
    private native static int __qt_critical_QWidget_String_String_StandardButtons_StandardButton(long parent, java.lang.String title, java.lang.String text, int buttons, int defaultButton);

    public static int critical(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text, com.trolltech.qt.gui.QMessageBox.StandardButton button0, com.trolltech.qt.gui.QMessageBox.StandardButton button1) {
        return __qt_critical_QWidget_String_String_StandardButton_StandardButton(parent == null ? 0 : parent.nativeId(), title, text, button0.value(), button1.value());
    }
    private native static int __qt_critical_QWidget_String_String_StandardButton_StandardButton(long parent, java.lang.String title, java.lang.String text, int button0, int button1);


    public static com.trolltech.qt.gui.QMessageBox.StandardButton information(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text, com.trolltech.qt.gui.QMessageBox.StandardButton button0) {
        return information(parent, title, text, button0, com.trolltech.qt.gui.QMessageBox.StandardButton.NoButton);
    }
    public static com.trolltech.qt.gui.QMessageBox.StandardButton information(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text, com.trolltech.qt.gui.QMessageBox.StandardButton button0, com.trolltech.qt.gui.QMessageBox.StandardButton button1) {
        return com.trolltech.qt.gui.QMessageBox.StandardButton.resolve(__qt_information_QWidget_String_String_StandardButton_StandardButton(parent == null ? 0 : parent.nativeId(), title, text, button0.value(), button1.value()));
    }
    private native static int __qt_information_QWidget_String_String_StandardButton_StandardButton(long parent, java.lang.String title, java.lang.String text, int button0, int button1);


    public static com.trolltech.qt.gui.QMessageBox.StandardButton information(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text, com.trolltech.qt.gui.QMessageBox.StandardButtons buttons) {
        return information(parent, title, text, buttons, com.trolltech.qt.gui.QMessageBox.StandardButton.NoButton);
    }

    public static com.trolltech.qt.gui.QMessageBox.StandardButton information(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text) {
        return information(parent, title, text, new com.trolltech.qt.gui.QMessageBox.StandardButtons(1024), com.trolltech.qt.gui.QMessageBox.StandardButton.NoButton);
    }
    public static com.trolltech.qt.gui.QMessageBox.StandardButton information(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text, com.trolltech.qt.gui.QMessageBox.StandardButtons buttons, com.trolltech.qt.gui.QMessageBox.StandardButton defaultButton) {
        return com.trolltech.qt.gui.QMessageBox.StandardButton.resolve(__qt_information_QWidget_String_String_StandardButtons_StandardButton(parent == null ? 0 : parent.nativeId(), title, text, buttons.value(), defaultButton.value()));
    }
    private native static int __qt_information_QWidget_String_String_StandardButtons_StandardButton(long parent, java.lang.String title, java.lang.String text, int buttons, int defaultButton);

    public static int question(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text, com.trolltech.qt.gui.QMessageBox.StandardButton button0, com.trolltech.qt.gui.QMessageBox.StandardButton button1) {
        return __qt_question_QWidget_String_String_StandardButton_StandardButton(parent == null ? 0 : parent.nativeId(), title, text, button0.value(), button1.value());
    }
    private native static int __qt_question_QWidget_String_String_StandardButton_StandardButton(long parent, java.lang.String title, java.lang.String text, int button0, int button1);


    public static com.trolltech.qt.gui.QMessageBox.StandardButton question(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text, com.trolltech.qt.gui.QMessageBox.StandardButtons buttons) {
        return question(parent, title, text, buttons, com.trolltech.qt.gui.QMessageBox.StandardButton.NoButton);
    }

    public static com.trolltech.qt.gui.QMessageBox.StandardButton question(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text) {
        return question(parent, title, text, new com.trolltech.qt.gui.QMessageBox.StandardButtons(1024), com.trolltech.qt.gui.QMessageBox.StandardButton.NoButton);
    }
    public static com.trolltech.qt.gui.QMessageBox.StandardButton question(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text, com.trolltech.qt.gui.QMessageBox.StandardButtons buttons, com.trolltech.qt.gui.QMessageBox.StandardButton defaultButton) {
        return com.trolltech.qt.gui.QMessageBox.StandardButton.resolve(__qt_question_QWidget_String_String_StandardButtons_StandardButton(parent == null ? 0 : parent.nativeId(), title, text, buttons.value(), defaultButton.value()));
    }
    private native static int __qt_question_QWidget_String_String_StandardButtons_StandardButton(long parent, java.lang.String title, java.lang.String text, int buttons, int defaultButton);


    public static com.trolltech.qt.gui.QMessageBox.StandardButton warning(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text, com.trolltech.qt.gui.QMessageBox.StandardButtons buttons) {
        return warning(parent, title, text, buttons, com.trolltech.qt.gui.QMessageBox.StandardButton.NoButton);
    }

    public static com.trolltech.qt.gui.QMessageBox.StandardButton warning(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text) {
        return warning(parent, title, text, new com.trolltech.qt.gui.QMessageBox.StandardButtons(1024), com.trolltech.qt.gui.QMessageBox.StandardButton.NoButton);
    }
    public static com.trolltech.qt.gui.QMessageBox.StandardButton warning(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text, com.trolltech.qt.gui.QMessageBox.StandardButtons buttons, com.trolltech.qt.gui.QMessageBox.StandardButton defaultButton) {
        return com.trolltech.qt.gui.QMessageBox.StandardButton.resolve(__qt_warning_QWidget_String_String_StandardButtons_StandardButton(parent == null ? 0 : parent.nativeId(), title, text, buttons.value(), defaultButton.value()));
    }
    private native static int __qt_warning_QWidget_String_String_StandardButtons_StandardButton(long parent, java.lang.String title, java.lang.String text, int buttons, int defaultButton);

    public static int warning(com.trolltech.qt.gui.QWidget parent, java.lang.String title, java.lang.String text, com.trolltech.qt.gui.QMessageBox.StandardButton button0, com.trolltech.qt.gui.QMessageBox.StandardButton button1) {
        return __qt_warning_QWidget_String_String_StandardButton_StandardButton(parent == null ? 0 : parent.nativeId(), title, text, button0.value(), button1.value());
    }
    private native static int __qt_warning_QWidget_String_String_StandardButton_StandardButton(long parent, java.lang.String title, java.lang.String text, int button0, int button1);


    public static native QMessageBox fromNativePointer(QNativePointer nativePointer);

    protected QMessageBox(QPrivateConstructor p) { super(p); } 

}
