package com.trolltech.qt.network;

import com.trolltech.qt.*;


@QtJambiGeneratedClass
public class QAbstractSocket extends com.trolltech.qt.core.QIODevice
{
    static {
        com.trolltech.qt.network.QtJambi_LibraryInitializer.init();
    }
    public enum SocketType implements com.trolltech.qt.QtEnumerator {
        TcpSocket(0),
        UdpSocket(1),
        UnknownSocketType(-1);

        SocketType(int value) { this.value = value; }
        public int value() { return value; }

        public static SocketType resolve(int value) {
            return (SocketType) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return TcpSocket;
            case 1: return UdpSocket;
            case -1: return UnknownSocketType;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum SocketError implements com.trolltech.qt.QtEnumerator {
        ConnectionRefusedError(0),
        RemoteHostClosedError(1),
        HostNotFoundError(2),
        SocketAccessError(3),
        SocketResourceError(4),
        SocketTimeoutError(5),
        DatagramTooLargeError(6),
        NetworkError(7),
        AddressInUseError(8),
        SocketAddressNotAvailableError(9),
        UnsupportedSocketOperationError(10),
        UnfinishedSocketOperationError(11),
        ProxyAuthenticationRequiredError(12),
        UnknownSocketError(-1);

        SocketError(int value) { this.value = value; }
        public int value() { return value; }

        public static SocketError resolve(int value) {
            return (SocketError) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return ConnectionRefusedError;
            case 1: return RemoteHostClosedError;
            case 2: return HostNotFoundError;
            case 3: return SocketAccessError;
            case 4: return SocketResourceError;
            case 5: return SocketTimeoutError;
            case 6: return DatagramTooLargeError;
            case 7: return NetworkError;
            case 8: return AddressInUseError;
            case 9: return SocketAddressNotAvailableError;
            case 10: return UnsupportedSocketOperationError;
            case 11: return UnfinishedSocketOperationError;
            case 12: return ProxyAuthenticationRequiredError;
            case -1: return UnknownSocketError;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum NetworkLayerProtocol implements com.trolltech.qt.QtEnumerator {
        IPv4Protocol(0),
        IPv6Protocol(1),
        UnknownNetworkLayerProtocol(-1);

        NetworkLayerProtocol(int value) { this.value = value; }
        public int value() { return value; }

        public static NetworkLayerProtocol resolve(int value) {
            return (NetworkLayerProtocol) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return IPv4Protocol;
            case 1: return IPv6Protocol;
            case -1: return UnknownNetworkLayerProtocol;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }
    public enum SocketState implements com.trolltech.qt.QtEnumerator {
        UnconnectedState(0),
        HostLookupState(1),
        ConnectingState(2),
        ConnectedState(3),
        BoundState(4),
        ListeningState(5),
        ClosingState(6);

        SocketState(int value) { this.value = value; }
        public int value() { return value; }

        public static SocketState resolve(int value) {
            return (SocketState) resolve_internal(value);
        }
        private static Object resolve_internal(int value) {
            switch (value) {
            case 0: return UnconnectedState;
            case 1: return HostLookupState;
            case 2: return ConnectingState;
            case 3: return ConnectedState;
            case 4: return BoundState;
            case 5: return ListeningState;
            case 6: return ClosingState;
            }
            throw new com.trolltech.qt.QNoSuchEnumValueException(value);
        }
        private final int value;

    }

    public final Signal0 connected = new Signal0();

    @SuppressWarnings("unused")
    private final void connected() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_connected(nativeId());
    }
    private native static void __qt_connected(long __this__nativeId);

    public final Signal0 disconnected = new Signal0();

    @SuppressWarnings("unused")
    private final void disconnected() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_disconnected(nativeId());
    }
    private native static void __qt_disconnected(long __this__nativeId);

    public final Signal1<com.trolltech.qt.network.QAbstractSocket.SocketError> error = new Signal1<com.trolltech.qt.network.QAbstractSocket.SocketError>();

    @SuppressWarnings("unused")
    private final void error(com.trolltech.qt.network.QAbstractSocket.SocketError arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_error_SocketError(nativeId(), arg__1.value());
    }
    private native static void __qt_error_SocketError(long __this__nativeId, int arg__1);

    public final Signal0 hostFound = new Signal0();

    @SuppressWarnings("unused")
    private final void hostFound() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_hostFound(nativeId());
    }
    private native static void __qt_hostFound(long __this__nativeId);

    private final Signal2<com.trolltech.qt.network.QNetworkProxy, com.trolltech.qt.QNativePointer> proxyAuthenticationRequiredPrivate = new Signal2<com.trolltech.qt.network.QNetworkProxy, com.trolltech.qt.QNativePointer>();

    @SuppressWarnings("unused")
    private final void proxyAuthenticationRequiredPrivate(com.trolltech.qt.network.QNetworkProxy proxy, com.trolltech.qt.QNativePointer authenticator) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_proxyAuthenticationRequiredPrivate_QNetworkProxy_nativepointer(nativeId(), proxy == null ? (proxy = new com.trolltech.qt.network.QNetworkProxy()).nativeId() : proxy.nativeId(), authenticator);
    }
    private native static void __qt_proxyAuthenticationRequiredPrivate_QNetworkProxy_nativepointer(long __this__nativeId, long proxy, com.trolltech.qt.QNativePointer authenticator);

    public final Signal1<com.trolltech.qt.network.QAbstractSocket.SocketState> stateChanged = new Signal1<com.trolltech.qt.network.QAbstractSocket.SocketState>();

    @SuppressWarnings("unused")
    private final void stateChanged(com.trolltech.qt.network.QAbstractSocket.SocketState arg__1) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_stateChanged_SocketState(nativeId(), arg__1.value());
    }
    private native static void __qt_stateChanged_SocketState(long __this__nativeId, int arg__1);

    public QAbstractSocket(com.trolltech.qt.network.QAbstractSocket.SocketType socketType, com.trolltech.qt.core.QObject parent) {
        super((QPrivateConstructor)null);
        __qt_QAbstractSocket_SocketType_QObject(socketType.value(), parent == null ? 0 : parent.nativeId());
    proxyAuthenticationRequired.connect(this, "emitProxyAuthenticationRequiredPrivate(QNetworkProxy, QAuthenticator)", com.trolltech.qt.core.Qt.ConnectionType.DirectConnection);
    proxyAuthenticationRequiredPrivate.connect(this, "emitProxyAuthenticationRequired(QNetworkProxy,QNativePointer)", com.trolltech.qt.core.Qt.ConnectionType.DirectConnection);

    }
    private native void __qt_QAbstractSocket_SocketType_QObject(int socketType, long parent);


    @QtBlockedSlot public final void abort() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_abort(nativeId());
    }
    private native static void __qt_abort(long __this__nativeId);


    @SuppressWarnings("unused")
    @QtBlockedSlot private final void connectToHost(com.trolltech.qt.network.QHostAddress address, char port, com.trolltech.qt.core.QIODevice.OpenModeFlag ... mode) {
        this.connectToHost(address, port, new com.trolltech.qt.core.QIODevice.OpenMode(mode));
    }

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void connectToHost(com.trolltech.qt.network.QHostAddress address, char port) {
        connectToHost(address, port, new com.trolltech.qt.core.QIODevice.OpenMode(3));
    }
    @SuppressWarnings("unused")
    @QtBlockedSlot private final void connectToHost(com.trolltech.qt.network.QHostAddress address, char port, com.trolltech.qt.core.QIODevice.OpenMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_connectToHost_QHostAddress_char_OpenMode(nativeId(), address == null ? (address = new com.trolltech.qt.network.QHostAddress()).nativeId() : address.nativeId(), port, mode.value());
    }
    private native static void __qt_connectToHost_QHostAddress_char_OpenMode(long __this__nativeId, long address, char port, int mode);


    @SuppressWarnings("unused")
    @QtBlockedSlot private final void connectToHost(java.lang.String hostName, char port, com.trolltech.qt.core.QIODevice.OpenModeFlag ... mode) {
        this.connectToHost(hostName, port, new com.trolltech.qt.core.QIODevice.OpenMode(mode));
    }

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void connectToHost(java.lang.String hostName, char port) {
        connectToHost(hostName, port, new com.trolltech.qt.core.QIODevice.OpenMode(3));
    }
    @SuppressWarnings("unused")
    @QtBlockedSlot private final void connectToHost(java.lang.String hostName, char port, com.trolltech.qt.core.QIODevice.OpenMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_connectToHost_String_char_OpenMode(nativeId(), hostName, port, mode.value());
    }
    private native static void __qt_connectToHost_String_char_OpenMode(long __this__nativeId, java.lang.String hostName, char port, int mode);


    @SuppressWarnings("unused")
    private final void connectToHostImplementation(java.lang.String hostName, char port, com.trolltech.qt.core.QIODevice.OpenModeFlag ... mode) {
        this.connectToHostImplementation(hostName, port, new com.trolltech.qt.core.QIODevice.OpenMode(mode));
    }

    @SuppressWarnings("unused")
    private final void connectToHostImplementation(java.lang.String hostName, char port) {
        connectToHostImplementation(hostName, port, new com.trolltech.qt.core.QIODevice.OpenMode(3));
    }
    @SuppressWarnings("unused")
    private final void connectToHostImplementation(java.lang.String hostName, char port, com.trolltech.qt.core.QIODevice.OpenMode mode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_connectToHostImplementation_String_char_OpenMode(nativeId(), hostName, port, mode.value());
    }
    private native static void __qt_connectToHostImplementation_String_char_OpenMode(long __this__nativeId, java.lang.String hostName, char port, int mode);

    @QtBlockedSlot public final void disconnectFromHost() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_disconnectFromHost(nativeId());
    }
    private native static void __qt_disconnectFromHost(long __this__nativeId);

    protected final void disconnectFromHostImplementation() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_disconnectFromHostImplementation(nativeId());
    }
    private native static void __qt_disconnectFromHostImplementation(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.network.QAbstractSocket.SocketError error() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.network.QAbstractSocket.SocketError.resolve(__qt_error(nativeId()));
    }
    private native static int __qt_error(long __this__nativeId);

    @QtBlockedSlot public final boolean flush() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_flush(nativeId());
    }
    private native static boolean __qt_flush(long __this__nativeId);

    @QtBlockedSlot public final boolean isValid() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isValid(nativeId());
    }
    private native static boolean __qt_isValid(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.network.QHostAddress localAddress() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_localAddress(nativeId());
    }
    private native static com.trolltech.qt.network.QHostAddress __qt_localAddress(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final char localPort_private() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_localPort_private(nativeId());
    }
    private native static char __qt_localPort_private(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.network.QHostAddress peerAddress() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_peerAddress(nativeId());
    }
    private native static com.trolltech.qt.network.QHostAddress __qt_peerAddress(long __this__nativeId);

    @QtBlockedSlot public final java.lang.String peerName() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_peerName(nativeId());
    }
    private native static java.lang.String __qt_peerName(long __this__nativeId);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final char peerPort_private() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_peerPort_private(nativeId());
    }
    private native static char __qt_peerPort_private(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.network.QNetworkProxy proxy() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_proxy(nativeId());
    }
    private native static com.trolltech.qt.network.QNetworkProxy __qt_proxy(long __this__nativeId);

    @QtBlockedSlot public final long readBufferSize() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readBufferSize(nativeId());
    }
    private native static long __qt_readBufferSize(long __this__nativeId);

    @QtBlockedSlot protected final void setLocalAddress(com.trolltech.qt.network.QHostAddress address) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLocalAddress_QHostAddress(nativeId(), address == null ? (address = new com.trolltech.qt.network.QHostAddress()).nativeId() : address.nativeId());
    }
    private native static void __qt_setLocalAddress_QHostAddress(long __this__nativeId, long address);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void setLocalPort(char port) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setLocalPort_char(nativeId(), port);
    }
    private native static void __qt_setLocalPort_char(long __this__nativeId, char port);

    @QtBlockedSlot protected final void setPeerAddress(com.trolltech.qt.network.QHostAddress address) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPeerAddress_QHostAddress(nativeId(), address == null ? (address = new com.trolltech.qt.network.QHostAddress()).nativeId() : address.nativeId());
    }
    private native static void __qt_setPeerAddress_QHostAddress(long __this__nativeId, long address);

    @QtBlockedSlot protected final void setPeerName(java.lang.String name) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPeerName_String(nativeId(), name);
    }
    private native static void __qt_setPeerName_String(long __this__nativeId, java.lang.String name);

    @SuppressWarnings("unused")
    @QtBlockedSlot private final void setPeerPort(char port) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setPeerPort_char(nativeId(), port);
    }
    private native static void __qt_setPeerPort_char(long __this__nativeId, char port);

    @QtBlockedSlot public final void setProxy(com.trolltech.qt.network.QNetworkProxy networkProxy) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setProxy_QNetworkProxy(nativeId(), networkProxy == null ? (networkProxy = new com.trolltech.qt.network.QNetworkProxy()).nativeId() : networkProxy.nativeId());
    }
    private native static void __qt_setProxy_QNetworkProxy(long __this__nativeId, long networkProxy);

    @QtBlockedSlot public final void setReadBufferSize(long size) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setReadBufferSize_long(nativeId(), size);
    }
    private native static void __qt_setReadBufferSize_long(long __this__nativeId, long size);


    @QtBlockedSlot public final boolean setSocketDescriptor(int socketDescriptor, com.trolltech.qt.network.QAbstractSocket.SocketState state, com.trolltech.qt.core.QIODevice.OpenModeFlag ... openMode) {
        return this.setSocketDescriptor(socketDescriptor, state, new com.trolltech.qt.core.QIODevice.OpenMode(openMode));
    }

    @QtBlockedSlot public final boolean setSocketDescriptor(int socketDescriptor, com.trolltech.qt.network.QAbstractSocket.SocketState state) {
        return setSocketDescriptor(socketDescriptor, state, new com.trolltech.qt.core.QIODevice.OpenMode(3));
    }

    @QtBlockedSlot public final boolean setSocketDescriptor(int socketDescriptor) {
        return setSocketDescriptor(socketDescriptor, com.trolltech.qt.network.QAbstractSocket.SocketState.ConnectedState, new com.trolltech.qt.core.QIODevice.OpenMode(3));
    }
    @QtBlockedSlot public final boolean setSocketDescriptor(int socketDescriptor, com.trolltech.qt.network.QAbstractSocket.SocketState state, com.trolltech.qt.core.QIODevice.OpenMode openMode) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_setSocketDescriptor_int_SocketState_OpenMode(nativeId(), socketDescriptor, state.value(), openMode.value());
    }
    private native static boolean __qt_setSocketDescriptor_int_SocketState_OpenMode(long __this__nativeId, int socketDescriptor, int state, int openMode);

    @QtBlockedSlot protected final void setSocketError(com.trolltech.qt.network.QAbstractSocket.SocketError socketError) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSocketError_SocketError(nativeId(), socketError.value());
    }
    private native static void __qt_setSocketError_SocketError(long __this__nativeId, int socketError);

    @QtBlockedSlot protected final void setSocketState(com.trolltech.qt.network.QAbstractSocket.SocketState state) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_setSocketState_SocketState(nativeId(), state.value());
    }
    private native static void __qt_setSocketState_SocketState(long __this__nativeId, int state);

    @QtBlockedSlot public final int socketDescriptor() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_socketDescriptor(nativeId());
    }
    private native static int __qt_socketDescriptor(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.network.QAbstractSocket.SocketType socketType() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.network.QAbstractSocket.SocketType.resolve(__qt_socketType(nativeId()));
    }
    private native static int __qt_socketType(long __this__nativeId);

    @QtBlockedSlot public final com.trolltech.qt.network.QAbstractSocket.SocketState state() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return com.trolltech.qt.network.QAbstractSocket.SocketState.resolve(__qt_state(nativeId()));
    }
    private native static int __qt_state(long __this__nativeId);


    @QtBlockedSlot public final boolean waitForConnected() {
        return waitForConnected((int)30000);
    }
    @QtBlockedSlot public final boolean waitForConnected(int msecs) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_waitForConnected_int(nativeId(), msecs);
    }
    private native static boolean __qt_waitForConnected_int(long __this__nativeId, int msecs);


    @QtBlockedSlot public final boolean waitForDisconnected() {
        return waitForDisconnected((int)30000);
    }
    @QtBlockedSlot public final boolean waitForDisconnected(int msecs) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_waitForDisconnected_int(nativeId(), msecs);
    }
    private native static boolean __qt_waitForDisconnected_int(long __this__nativeId, int msecs);

    @QtBlockedSlot public boolean atEnd() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_atEnd(nativeId());
    }
    private native static boolean __qt_atEnd(long __this__nativeId);

    @QtBlockedSlot public long bytesAvailable() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bytesAvailable(nativeId());
    }
    private native static long __qt_bytesAvailable(long __this__nativeId);

    @QtBlockedSlot public long bytesToWrite() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_bytesToWrite(nativeId());
    }
    private native static long __qt_bytesToWrite(long __this__nativeId);

    @QtBlockedSlot public boolean canReadLine() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_canReadLine(nativeId());
    }
    private native static boolean __qt_canReadLine(long __this__nativeId);

    @QtBlockedSlot public void close() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        __qt_close(nativeId());
    }
    private native static void __qt_close(long __this__nativeId);

    @QtBlockedSlot public boolean isSequential() {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_isSequential(nativeId());
    }
    private native static boolean __qt_isSequential(long __this__nativeId);

    @QtBlockedSlot protected int readData(byte[] data) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readData_nativepointer_long(nativeId(), data);
    }
    private native static int __qt_readData_nativepointer_long(long __this__nativeId, byte[] data);

    @QtBlockedSlot protected int readLineData(byte[] data) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_readLineData_nativepointer_long(nativeId(), data);
    }
    private native static int __qt_readLineData_nativepointer_long(long __this__nativeId, byte[] data);

    @QtBlockedSlot public boolean waitForBytesWritten(int msecs) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_waitForBytesWritten_int(nativeId(), msecs);
    }
    private native static boolean __qt_waitForBytesWritten_int(long __this__nativeId, int msecs);

    @QtBlockedSlot public boolean waitForReadyRead(int msecs) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_waitForReadyRead_int(nativeId(), msecs);
    }
    private native static boolean __qt_waitForReadyRead_int(long __this__nativeId, int msecs);

    @QtBlockedSlot protected int writeData(byte[] data) {
        com.trolltech.qt.QtJambiInternal.threadCheck(this);
        if (nativeId() == 0)
            throw new QNoNativeResourcesException("Function call on incomplete object of type: " +getClass().getName());
        return __qt_writeData_nativepointer_long(nativeId(), data);
    }
    private native static int __qt_writeData_nativepointer_long(long __this__nativeId, byte[] data);


    public static native QAbstractSocket fromNativePointer(QNativePointer nativePointer);

   @Override
   @QtBlockedSlot protected boolean __qt_signalInitialization(String name) {
       return (__qt_signalInitialization(nativeId(), name)
               || super.__qt_signalInitialization(name));
   } 
   @QtBlockedSlot private native boolean __qt_signalInitialization(long ptr, String name);

    protected QAbstractSocket(QPrivateConstructor p) { super(p); } 


        public Signal2<QNetworkProxy, QAuthenticator> proxyAuthenticationRequired = new Signal2<QNetworkProxy, QAuthenticator>();
        private boolean inEmission = false;
        
        @SuppressWarnings("unused")
        private void emitProxyAuthenticationRequiredPrivate(QNetworkProxy proxy, QAuthenticator authenticator) 
        {
            if (!inEmission) {           
                inEmission = true;
                proxyAuthenticationRequiredPrivate.emit(proxy, authenticator.nativePointer());
                inEmission = false;
            }
        }
        
        @SuppressWarnings("unused")
        private void emitProxyAuthenticationRequired(QNetworkProxy proxy, QNativePointer authenticator) 
        {
            if (!inEmission) {
                inEmission = true;
                proxyAuthenticationRequired.emit(proxy, QAuthenticator.fromNativePointer(authenticator));
                inEmission = false;
            }
        }
    

    public final void connectToHost(String host, int port, com.trolltech.qt.core.QIODevice.OpenMode mode) {
        connectToHost(host, (char) port, mode);
    }
    public final void connectToHost(QHostAddress host, int port, com.trolltech.qt.core.QIODevice.OpenMode mode) {
        connectToHost(host, (char) port, mode);
    }
    protected final void connectToHostImplementation(String host, int port, com.trolltech.qt.core.QIODevice.OpenMode mode) {
        connectToHostImplementation(host, (char) port, mode);
    }
    public final int localPort() { return localPort_private(); }
    public final int peerPort() { return peerPort_private(); }
    protected final void setLocalPort(int port) { 
        setLocalPort((char) port);
    }
    protected final void setPeerPort(int port) {
        setPeerPort((char) port);
    }
    
}
